#include <vector>
#include <unordered_map>
#include "testlib.h"

using namespace std;

pair<unsigned int, long long> check(unordered_map<int, unsigned int> const &taken, vector<long long> const &data) {
    long long sum = 0;
    unsigned int mcnt = 0;
    for (auto const &p : taken) {
        sum += data[p.first] * p.second;
        mcnt = max(mcnt, p.second);
    }
    return {mcnt, sum};
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    unsigned int n = inf.readInt(), m = inf.readInt(), k = inf.readInt();
    vector<long long> data;
    for (unsigned int i = 0; i < n; i++) {
        data.push_back(inf.readInt());
    }

    unordered_map<int, unsigned int> sans, sout;
    for (unsigned int i = 0; i < m; i++) {
        sans[ans.readInt() - 1]++;
        int idx = ouf.readInt() - 1;
        if (idx < 0 || idx > n - 1) {
            quitf(_wa, "Invalid index %d in output", idx);
        }
        sout[idx]++;
    }
    if (sout.size() < k) {
        quitf(_wa, "Contestant's answer has les than %u different elements", k);
    }

    auto pans = check(sans, data);
    auto pout = check(sout, data);
    if (pans.second > pout.second) {
        quitf(_wa, "Contestant's output %lld is lesser than answer %lld", pout.second, pans.second);
    } else if (pans.second < pout.second) {
        quitf(_fail, "Contestant's output %lld is greater than answer %lld", pout.second, pans.second);
    } else {
        if (pans.first < pout.first) {
            quitf(_wa, "Contestant has %u of the same element, jury has %u",
                  pout.first, pans.first);
        } else if (pans.first > pout.first) {
            quitf(_fail, "Contestant has a solution with at most %u of the same element, jury has %u",
                  pout.first, pans.first);
        } else {
            quit(_ok, "Ok");
        }
    }

}